-- Geist, by Cidrei (Jazrei of Zangarmarsh-US)

-- Local Table
local aName, aTable = ...

-- OnEvent
function aTable.OnEvent(self, event, ...)
	if ( event == "ADDON_LOADED" ) then
		local addonName = ...
		if ( not addonName or (addonName and addonName ~= "Geist") ) then
			return;
		end
		SLASH_GEIST1 = "/geist"
		SLASH_GEIST2 = "/gbm" -- Legacy commands ftw.
		SlashCmdList["GEIST"] = aTable.ChatCommandHandler

		aTable.SavedVars()
		aTable.Create()
		aTable.DisplayGuide()
	end
end

-- Saved variables
function aTable.SavedVars()
	if Geist == nil then
		Geist = {}
	end

	if Geist["Scale"] == nil then
		Geist["Scale"] = 1
	end

	if Geist["ButtonIDs"] == nil then
		Geist["ButtonIDs"] = {}
		local _, class = UnitClass("player")

		if class == "DRUID" then
			Geist["ButtonIDs"] = aTable.ButtonIDs["DRUID"]
		elseif class == "WARRIOR" then
			Geist["ButtonIDs"] = aTable.ButtonIDs["WARRIOR"]
		else
			Geist["ButtonIDs"] = aTable.ButtonIDs["DEFAULT"]
		end
	end

	if Geist["Buttons"] == nil then
		Geist["Buttons"] = 25
	end

end

-- Chat output
function aTable.Print(msg) 
	if not DEFAULT_CHAT_FRAME then
		return
	end

	DEFAULT_CHAT_FRAME:AddMessage(msg)
end

-- Scale
function aTable.SetScale(scale)
	if GeistHeader then
		GeistHeader:SetScale(scale)
		Geist["Scale"] = scale
	else
		return
	end
end

function aTable.ResetScale()
	if(GetCVar("useUiScale") == "0") then	
		Geist["Scale"] = 1
	else
		Geist["Scale"] = GetCVar("uiscale")
		GeistHeader:SetScale(GetCVar("uiscale"))
	end
end

-- Guide
function aTable.DisplayGuide()
	for i = 1, table.getn(aTable.Buttons) do
		if Geist["Guide"] then
			aTable.Buttons[i].title:Show()
		else
			aTable.Buttons[i].title:Hide()
		end
	end
end

-- Local event frame
local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", aTable.OnEvent)
